Attribute VB_Name = "Module1"
Option Explicit
Public Const Pi = 3.14159265358979
Public Const qq = Pi / 180 '     

Public TAU#, TextHour!, TextMin!, TextSek!

' 
Public Sub PrintCom(st As String)
 Form1.txtcom.Text = Form1.txtcom.Text & Chr(13) & Chr(10) & st
End Sub

'   d()   (az,h)
Public Sub CreateVector(Az As Double, H As Double, r As Double, d() As Double)
 d(1) = r * Cos(Az * qq) * Cos(H * qq)
 d(2) = r * Sin(Az * qq) * Cos(H * qq)
 d(3) = r * Sin(H * qq)
End Sub

'    B  Y   ( )
Public Sub CreateMatrixY(A As Double, b() As Double)
 Dim T As Double
 T = A * qq
 b(1, 1) = Cos(T): b(2, 1) = 0: b(3, 1) = Sin(T)
 b(1, 2) = 0: b(2, 2) = 1: b(3, 2) = 0
 b(1, 3) = -Sin(T): b(2, 3) = 0: b(3, 3) = Cos(T)
End Sub

'    B  Z   ( )
Public Sub CreateMatrixZ(A As Double, b() As Double)
 Dim T As Double
 T = A * qq
 b(1, 1) = Cos(T): b(2, 1) = -Sin(T): b(3, 1) = 0
 b(1, 2) = Sin(T): b(2, 2) = Cos(T): b(3, 2) = 0
 b(1, 3) = 0: b(2, 3) = 0: b(3, 3) = 1
End Sub

' C=A*b    
' A[3,3], b[3]
Public Sub MultiplyArray(A() As Double, b() As Double, C() As Double)
 Dim i As Byte, j As Byte, s As Double
 For j = 1 To 3
  s = 0
   For i = 1 To 3
    s = s + A(i, j) * b(i)
   Next i
  C(j) = s
 Next j
 End Sub

'   (ra,dec)   r()
Public Sub Angles_from_Vector(r() As Double, Ra As Double, Dec As Double)
 Ra = Atn2(r(2), r(1)) / qq
 Dec = Atn2(r(3), Sqr(r(1) ^ 2 + r(2) ^ 2)) / qq
 If Ra < 0 Then Ra = Ra + 360
End Sub

'   -I (th,dec)   (az,h)   Lat
Public Sub AzimuthCoordinate(th As Double, Dec As Double, Lat As Double, Az As Double, H As Double)
 Dim sinh As Double, z As Double, SinAz As Double, CosAz As Double
 sinh = Sin(Lat * qq) * Sin(Dec * qq) + Cos(Lat * qq) * Cos(Dec * qq) * Cos(th * qq)
 H = ArcSin(sinh) / qq
 SinAz = Sin(th * qq) * Cos(Dec * qq) / Cos(H * qq)
 CosAz = (Sin(H * qq) * Sin(Lat * qq) - Sin(Dec * qq)) / Cos(H * qq) / Cos(Lat * qq)
 Az = Atn2(SinAz, CosAz) / qq
 'If Az < 0 Then Az = Az + 360
End Sub

'       
Public Function Angle_Distance(ra1 As Double, ra2 As Double, dec1 As Double, dec2 As Double) As Double
 Dim cosa As Double
 cosa = Sin(dec1 * qq) * Sin(dec2 * qq) + Cos(dec1 * qq) * Cos(dec2 * qq) * Cos((ra1 - ra2) * qq)
 Angle_Distance = ArcCos(cosa) / qq
End Function

Public Function LMST(MJD As Double) As Double ' local mean sidereal time
'FUNCTION LMST(MJD,LAMBDA:REAL):REAL;
'MJD = JD - 2400000.5
Dim t1#, T2#
T2 = (MJD - Fix(MJD)) * 24: t1 = (Fix(MJD) - 51544.5) / 36525
LMST = 6.697374558 + 1.0027379093 * T2 + (8640184.812866 + (0.093104 - 0.0000062 * t1) * t1) * t1 / 3600# '
End Function

Public Sub HourMin(IDay_LT As Double) '     ,   
TextHour = (IDay_LT - Fix(IDay_LT)) * 24
TextMin = Fix((TextHour - Fix(TextHour)) * 60)
TextSek = Fix((TextHour - Fix(TextHour) - TextMin / 60) * 3600)
TextHour = Fix(TextHour)
End Sub
